Bug 967950 - std::chrono clocks changed default resolution
std::chrono clocks changed default resolution
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: gcc (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-28 12:09 EDT by Marcel Hellwig
Modified: 2015-02-18 06:20 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 06:20:49 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Marcel Hellwig 2013-05-28 12:09:17 EDT
Description of problem:
When compiling simple programm from [0] the times are much higher than with gcc 4.8.0-6. 
Either there is a bug with compilation (I see that in the changelog something with ABI break is mentioned) or the steady clock is not working as expected.

How reproducible:
Compile and run

Actual results:
Much higher times than expected.

[0] http://en.cppreference.com/w/cpp/chrono/steady_clock/now
Comment 1 Jakub Jelinek 2013-05-28 12:25:24 EDT
Why do you think it is a bug?  .count() is really just raw units, the old steady_clock wasn't really steady and had microseconds resolution, the new one (mangles differently; and system_clock too) both have nanosecond resolution.
I guess you want to use other interfaces than .count() if you want to transform it into seconds, microseconds, nanoseconds etc.
Comment 2 Marcel Hellwig 2013-05-28 12:29:42 EDT
Hmmm. Alright. I was wondered because 4.8.0-6 had such "small" numbers and out of the sudden they were that big. And the cppreference had also the small numbers. Thats why I thought it is a bug.
Thanks for your answer.
Comment 3 Benjamin Kosnik 2013-05-29 14:00:17 EDT
Hey Marcel! Yes, the default resolution of the system clocks changed (for the better, IMHO.) That's why you are seeing bigger numbers.

As Jakub stated, this is a feature, not a bug. For typed time values, use c++11's std::duration type. That way you as a programmer can explicitly state the resolution you require, along with the actual value, so that conversions to other resolutions are sane.

Perhaps I should note the change in default clock resolution in 4_8/porting_to.html.

-benjamin
Comment 4 Benjamin Kosnik 2013-05-29 14:01:56 EDT
I'm going to edit this subject so that it's more descriptive.
Comment 5 Fedora End Of Life 2015-01-09 17:41:57 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 6 Fedora End Of Life 2015-02-18 06:20:49 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.